## maas 1.7.3+bzr3363

=== debian/changelog ===
maas (1.7.3+bzr3363-0ubuntu1) vivid; urgency=medium

  * New upstream bugfix release, 1.7.3 bzr3363:
    - Fix sorting by MAC address on node listing page (LP: #1437094)
    - Automatically set correct boot resources and start re-import
      so MAAS is usable after upgrade from 1.5. (LP: #1439359)
    - Maintain backwards compatibility with MAAS 1.5 (custom) preseeds names
      so users don't have to manually change preseed names. (LP: #1439366)
    - Expose the version and the subversion of the running MAAS
      on the API. (LP: #1441133)
    - Fix Internal Server Error when saving a cluster without specifying
      Router IP. (LP: #1441933) 
  - debian/patches/02-pserv-config.patch: Ensure pserv config file has a
    default. This will also fix (LP: #1273197)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 24 Mar 2015 15:56:10 -0400

maas (1.7.2+bzr3355-0ubuntu1) trusty; urgency=medium

  * New upstream release, 1.7.2 bzr3355:
    - Support AMT Version > 8 (LP: #1331214)
    - Fix call to amttool when restarting a node to not fail
      disk erasing. (LP: #1397567)
    - Do not generate the 'option routers' stanza if router IP
      is None. (LP: #1415538)
    - Do not deallocate StaticIPAddress before node has powered
      off. (LP: #1403909)
    - Remove all OOPS reporting. (LP: #1405998)
    - Update node host maps when a sticky ip address is claimed
      over the API. (LP: #1423931)
  * debian/control:
    - Depends on ubuntu-cloudimage-keyring for region (LP: #1424287)
    - Depends on pxelinux instead of syslinux-dev (LP: #1433697)
  * Drop dependencies on python-oops* and add dependency to python-bson.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 30 Jan 2015 11:58:07 +0000

maas (1.7.1+bzr3341-0ubuntu1) vivid; urgency=medium

  * New upstream release, 1.7.1 bzr3341:
    - Fix crash when trying to add an empty network. (LP: #1414036)
    - Fix Add Node WebUI Page to not display OS/Release if
      not populated (LP: #1413030)
    - Fix Power8 VM enlistment to correctly by correctly parsing the 
      MAC address. (LP: #1409952)
    - Fix IP Address reservation to not fail when trying to reserve
      an IP address. (LP: #1409852) 
    - Fix probe-and-enlist locking up cluster (LP: #1403609)
    - Fix slow node event log queries (LP: #1402237)
    - Fix marking settings page as active when viewing node page
      (LP: #1403043)
    - Fix broken zone link on node page (LP: #1402736)
    - Fix cluster process from uses high levels of CPU on web
      requests (LP: #1401707)
    - Update API documentation for error codes (LP: #1391193)
    - Do not query broken nodes power state (LP: #1402243)
    - Display MAC address node booted from on node listing
      (LP: #1399676)
    - Show node memory size in MiB or GiB (LP: #1399736)
    - Fix deadlock caused by updating nodes PXE MAC address
      on every PXE request (LP: #1401983)
    - Fix auto creation of networks using the interface name
      instead of the cluster name (LP: #1400909)
    - Fix node page to display memory in GiB (LP: #1401349)
    - Fix to maas not knowing about VM paused state (LP: #1394382)
    - Fix CustomOS image by returning the correct filename and path
      (LP: #1401241, LP: #1393953)
    - Don't query for node info when we don't have a MAC address when
      accessing the TFTP server from local machine. (LP: #1398159)
    - Ensure PXE MAC address is the first reported to MAAS on 
      enlistment (LP: #1400849)
    - Do not use poweroff.c32/poweroff.com as some systems don't
      support it. Instead use the ephemeral environment to issue a
      poweroff command. (LP: #1376716)
    - Pipe script commands to /bind/sh instead of using shell=True 
      to prevent showing error output of px ax (LP: #1399331)
    - Do not delete node's connected to a cluster interface, if
      the latter gets removed. (LP: #1396308)
    - Ensure disk erasing always runs the commissioning
      ephemeral image (LP: #1397193)
    - Add capability to use an option prefix_filer parameter to
      probe_and_enlist_hardware when the model is virsh (LP: #1393423)
    - Add capability to query power status for sm15k (LP: #1384424)
    - Add capability to query power status for UCSM (LP: #1384426)
    - Ensure WSGI has a home defined for the user. (LP: #1399016)

  [ Jeroen Vermeulen ]
  * debian/maas-cluster-controller.postinst: configure MAAS_URL through new
    "maas-provision configure-maas-url" sub-command instead of with "sed".

  [ Andres Rodriguez ]
  * Set 'maas' homedir to '/var/lib/maas' (LP: #1399016):
    - debian/maas-common.postinst: Do not try to update 'maas'
      home user dir on upgrade.
  * debian/control: Tighten Dependency Versioning of some packages.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 30 Jan 2015 11:47:16 +0000

maas (1.7.0+bzr3299-0ubuntu1) utopic; urgency=medium

  * New upstream release, 1.7.0.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 14 Nov 2014 08:38:39 -0500

maas (1.7.0~rc3+bzr3299-0ubuntu1) utopic; urgency=medium

  * New upstream release, RC3 bzr 3299
    - Fix dashboard tooltip messages which had stopped being displayed
      (LP: #1390434)

 -- Julian Edwards <julian.edwards@canonical.com>  Tue, 11 Nov 2014 12:23:07 +1000

maas (1.7.0~rc2+bzr3297-0ubuntu1) utopic; urgency=medium

  * New upstream release, RC2 bzr 3297
    - Allow marking a node in the DISK_ERASING state as broken (LP: #1388919)
    - Prevent concurrent allocations of static IP addresses from returning
      the same clashing address. (LP: #1387262)

  [ Andres Rodriguez ]
  * debian/maas-cluster-controller.postinst: Make sure that cluster sets
    the correct permissions for proxy log dir if running on the same
    system. (LP: #1377964)

 -- Julian Edwards <julian.edwards@canonical.com>  Fri, 07 Nov 2014 09:30:52 +1000

maas (1.7.0~rc1+bzr3295-0ubuntu1) trusty; urgency=medium

  * New Upstream Release, RC1 bzr 3295
    - If using MSCM (Moonshot Chassis Manager) on a M300, do not overwrite


=== debian/control ===
Source: maas
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 8.1.0~),
               dh-apport,
               po-debconf,
               python (>= 2.7),
               python-distribute,
               python-django
Standards-Version: 3.9.4
X-Python-Version: >= 2.7
Homepage: https://launchpad.net/maas

Package: maas
Architecture: all
Depends: ${misc:Depends},
 maas-cluster-controller (= ${binary:Version}),
 maas-region-controller (= ${binary:Version}),
 python-django-maas (= ${binary:Version})
Description: MAAS server all-in-one metapackage
 MAAS is "Metal As A Service", a system for dynamic provisioning of physical
 servers that has many of the same characteristics as a cloud.  You register
 servers with MAAS by telling MAAS about their IPMI or other control system.
 MAAS can then do hardware inventory, and provision that system on demand
 with whatever OS and software you like.  MAAS is standalone software that
 works with any configuration system, but for best results combine MAAS with
 Juju.
 .
 MAAS provides:
  * Hardware inventory of servers
  * Dynamic provisioning based on name or attributes such as disk, RAM cores, sockets
  * DNS and DHCP as needed
  * PXE boot services
 .
 This package is a metapackage which installs all of the separate components
 of MAAS on a single machine.

Package: maas-common
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Description: MAAS server common files
 This package contains the common files for any MAAS installation.

Package: maas-region-controller-min
Architecture: all
Depends: apache2,
         bind9utils,
         dbconfig-common,
         iproute,
         libapache2-mod-wsgi,
         libjs-raphael,
         libjs-yui3-full,
         libjs-yui3-min,
         maas-common (= ${binary:Version}),
         python-django (>= 1.4),
         python-django-maas (= ${binary:Version}),
         python-django-piston,
         python-django-south,
         python-maas-provisioningserver (= ${binary:Version}),
         python-djorm-ext-pgarray,
         rsyslog,
         ubuntu-cloudimage-keyring,
         maas-proxy (= ${binary:Version}),
         ${misc:Depends},
         ${python:Depends}
Breaks: maas-region-controller ( <= 1.4+bzr1693+dfsg-0ubuntu3 )
Replaces: maas-region-controller ( <= 1.4+bzr1693+dfsg-0ubuntu3 )
Description: MAAS Server minimum region controller
 This package installs and configures the minimum region controller
 services provided by MAAS, including the web UI, caching package proxy,
 networking/traffic control, and remote logging system.

Package: maas-region-controller
Architecture: all
Depends: maas-region-controller-min (= ${binary:Version}),
         postgresql (>= 9.1),
         ${misc:Depends},
         ${python:Depends}
Recommends: openssh-server, maas-dns (= ${binary:Version})
Description: MAAS server complete region controller
 This package installs and configures the complete MAAS region controller,
 including the minimum setup, plus the database server and messaging queue.

Package: python-maas-provisioningserver
Section: python
Architecture: all
Depends: python-bson,
         python-celery,
         python-crochet,
         python-distro-info,
         python-formencode,
         python-jsonschema,
         python-lockfile,
         python-lxml,
         python-maas-client (= ${binary:Version}),
         python-netifaces,
         python-paramiko,
         python-pexpect,
         python-pyparsing,
         python-seamicroclient,
         python-simplestreams,
         python-tempita,
         python-twisted-core,
         python-twisted-web,
         python-txamqp,
         python-txtftp,
         python-yaml,
         python-zope.interface,
         ${misc:Depends},
         ${python:Depends}
Breaks: python-django-maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-cluster-controller (<= 0.1+bzr1243+dfsg-0ubuntu3), maas-dhcp (<= 1.4+bzr1817+dfsg-0ubuntu1)
Replaces: python-django-maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-cluster-controller (<= 0.1+bzr1243+dfsg-0ubuntu3), maas-dhcp (<= 1.4+bzr1817+dfsg-0ubuntu1)
Description: MAAS server provisioning libraries
 This package provides the MAAS provisioning server python libraries.

Package: maas-cli
Architecture: all
Depends: python-bzrlib,
         python-httplib2,
         python-maas-client (= ${binary:Version}),
         python-oauth,
         ${misc:Depends},
         ${python:Depends}
Conflicts: maas-region-controller-min (<= 1.5+bzr1909-0ubuntu1)
Replaces: maas-region-controller-min (<= 1.5+bzr1909-0ubuntu1)
Description: MAAS command line API tool
 This package contains the MAAS client command line API tool.
 This tool enables automation of tasks in MAAS, remotely, through
 its API.

Package: python-maas-client
Section: python
Architecture: all
Depends: python-oauth, ${misc:Depends}, ${python:Depends}
Breaks: maas (<= 0.1+bzr971+dfsg-0ubuntu2 )
Replaces: maas (<= 0.1+bzr971+dfsg-0ubuntu2 )
Description: MAAS python API client
 This package contains the MAAS client API Python modules.

Package: maas-cluster-controller
Architecture: all
Depends: apache2,
         authbind,
         bind9utils,
         distro-info,
         freeipmi-tools,
         grub-common,
         maas-cli (=${binary:Version}),
         maas-common (=${binary:Version}),
         maas-dhcp (=${binary:Version}),
         python-httplib2,
         python-lockfile,
         python-maas-provisioningserver (=${binary:Version}),
         python-netaddr,
         python-oauth,
         python-tempita,
         python-twisted,
         python-zope.interface,
         rsyslog,
         pxelinux | syslinux-common (<< 3:6.00~pre4+dfsg-5),
         syslinux-common,
         tgt,
         ubuntu-cloudimage-keyring,
         uuid-runtime,
         wget,
         ${misc:Depends},
         ${python:Depends}
Suggests: ipmitool, libvirt-bin, amtterm
Conflicts: tftpd-hpa
Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-region-controller ( <= 0.1+bzr1314+dfsg-0ubuntu1 )
Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 ), maas-region-controller ( <= 0.1+bzr1314+dfsg-0ubuntu1 )
Description: MAAS server cluster controller
 This package contains the MAAS cluster controller, which is responsible
 for enabling and controlling remote DHCP/TFTP instances on their own
 subnets.

Package: python-django-maas
Section: python
Architecture: all
Depends: python-amqp,
         python-bson,
         python-celery,
         python-convoy,
         python-crochet,
         python-curtin,
         python-lockfile,
         python-lxml,
         python-maas-client (= ${binary:Version}),
         python-netaddr,
         python-psycopg2,
         python-sphinx,
         python-tempita,
         python-twisted,
         python-txamqp,
         python-zope.interface,
         ${misc:Depends},
         ${python:Depends}
Description: MAAS server Django web framework
 This package provides the Django web framework for MAAS.

Package: maas-dhcp
Architecture: all
Depends: isc-dhcp-server (>= 4.2.4), ${misc:Depends}
Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Replaces: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Description: MAAS DHCP server
 This package installs and configures a DHCP server that can be used by
 MAAS, and enhances the overall MAAS user experience.

Package: maas-dns
Architecture: all
Depends: bind9,
 maas-region-controller-min (= ${binary:Version}),
 python-iscpy,
 ${misc:Depends}
Conflicts: dnsmasq
Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Replaces: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)
Description: MAAS DNS server
 This package installs and configures a DNS server that can be used by
 MAAS, and enhances the overall MAAS user experience.

Package: maas-proxy
Architecture: all
Depends: ${python:Depends},
         ${misc:Depends},
         squid3
Conflicts: squid-deb-proxy
Replaces: squid-deb-proxy
Description: MAAS Caching Proxy
 This package installs and configures a Caching Proxy server that can be
 used by MAAS. It enhances the overall MAAS user experience.

=== debian/rules ===
#!/usr/bin/make -f

BUILDHOME = $(CURDIR)/debian/build
PYTHON = $(shell pyversions -d)
# Python enum modules.
py_enums := $(wildcard src/*/enum.py)

%:
	dh $@ --with python2,apport --buildsystem=python_distutils

override_dh_installinit:
	dh_installinit --name maas-clusterd
	dh_installinit --name maas-dhcpd
	dh_installinit --name maas-dhcpd6
	dh_installinit --name maas-proxy

override_dh_auto_build:
	dh_auto_build

	mkdir -p $(BUILDHOME)
	HOME=$(BUILDHOME) PYTHONPATH=$(CURDIR)/src/ $(PYTHON)	\
		$(CURDIR)/src/maasserver/utils/jsenums.py	\
		$(py_enums) > $(BUILDHOME)/enums.js

override_dh_auto_install:
	dh_auto_install

	# Move static files
	install -d -m 755  $(CURDIR)/debian/tmp/usr/share/maas/web/static
	mv $(CURDIR)/debian/tmp/usr/lib/python*/*-packages/maasserver/static \
                $(CURDIR)/debian/tmp/usr/share/maas/web/

	# Install built enums.js file.
	cp $(BUILDHOME)/enums.js $(CURDIR)/debian/tmp/usr/share/maas/web/static/js/

	# install the apparmor profile
	install -d -m 755 $(CURDIR)/debian/tmp/etc/apparmor.d/dhcpd.d
	install -m 644 $(CURDIR)/debian/maas-dhcp.apparmor \
	    $(CURDIR)/debian/tmp/etc/apparmor.d/dhcpd.d/maas

	dh_install --list-missing

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDHOME)
	rm -rf src/*.egg-info

DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
REV=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: .*[+~]bzr([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
get-orig-source:
	bzr export -r $(REV) --root=maas-$(VER).orig \
             maas_$(VER).orig.tar.gz lp:maas/1.7

## maas 1.7.6+bzr3376

=== Makefile ===
python := python2.7

# Network activity can be suppressed by setting offline=true (or any
# non-empty string) at the command-line.
ifeq ($(offline),)
buildout := bin/buildout
virtualenv := virtualenv
else
buildout := bin/buildout buildout:offline=true
virtualenv := virtualenv --never-download
endif

# If offline has been selected, attempt to further block HTTP/HTTPS
# activity by setting bogus proxies in the environment.
ifneq ($(offline),)
export http_proxy := broken
export https_proxy := broken
endif

# Python enum modules.
py_enums := $(wildcard src/*/enum.py)
# JavaScript enum module (not modules).
js_enums := src/maasserver/static/js/enums.js

# Prefix commands with this when they need access to the database.
# Remember to add a dependency on bin/database from the targets in
# which those commands appear.
dbrun := bin/database --preserve run --

# For things that care, postgresfixture for example, we always want to
# use the "maas" databases.
export PGDATABASE := maas

# For anything we start, we want to hint as to its root directory.
export MAAS_ROOT := $(CURDIR)/run

build: \
    bin/buildout \
    bin/database \
    bin/maas-region-admin bin/test.maas \
    bin/maas bin/test.maascli \
    bin/test.maastesting \
    bin/twistd.pserv bin/test.pserv \
    bin/test.config \
    bin/maas-probe-dhcp \
    bin/py bin/ipy \
    $(js_enums)

all: build doc

# Install all packages required for MAAS development & operation on
# the system. This may prompt for a password.
install-dependencies:
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    --no-install-recommends install $(shell sort -u \
	        $(addprefix required-packages/,base build dev doc))
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    purge $(shell sort -u required-packages/forbidden)

bin/python:
	$(virtualenv) --python=$(python) --system-site-packages $(CURDIR)

bin/buildout: bin/python bootstrap/zc.buildout-1.5.2.tar.gz
	bin/python -m pip --quiet install --ignore-installed \
	    --no-dependencies bootstrap/zc.buildout-1.5.2.tar.gz
	$(RM) -f README.txt  # zc.buildout installs an annoying README.txt.
	@touch --no-create $@  # Ensure it's newer than its dependencies.

bin/database: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install database
	@touch --no-create $@

bin/maas-region-admin: \
    bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install maas
	@touch --no-create $@

bin/test.maas: bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install maas-test
	@touch --no-create $@

bin/maas: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install maascli
	@touch --no-create $@

bin/test.maascli: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install maascli-test
	@touch --no-create $@

bin/test.maastesting: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install maastesting-test
	@touch --no-create $@

bin/maas-provision bin/twistd.pserv: \
    bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install pserv
	@touch --no-create $@

bin/test.pserv: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install pserv-test
	@touch --no-create $@

bin/test.config: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install config-test
	@touch --no-create $@

bin/maas-probe-dhcp: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install maas-probe-dhcp
	@touch --no-create $@

bin/flake8: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install flake8
	@touch --no-create $@

bin/sphinx bin/sphinx-build: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install sphinx
	@touch --no-create $@

bin/py bin/ipy: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install repl
	@touch --no-create bin/py bin/ipy

test: build
	echo $(wildcard bin/test.*) | xargs -n1 env

lint: lint-py lint-js lint-doc

pocketlint = $(call available,pocketlint,python-pocket-lint)

# XXX jtv 2014-02-25: Clean up this lint, then make it part of "make lint".
lint-css: sources = src/maasserver/static/css
lint-css:
	@find $(sources) -type f \
	    -print0 | xargs -r0 $(pocketlint) --max-length=120

# Python lint checks are time-intensive, so we run them in parallel.  It may
# make things matters worse if the files need to be read from disk, though, so
# this may need more tuning.
# The -n50 -P4 setting roughly doubled speed on a high-end system with SSD and
# all the files in cache.
lint-py: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
lint-py: bin/flake8
	@find $(sources) -name '*.py' ! -path '*/migrations/*' -print0 \
	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123 --config=/dev/null
	@./utilities/check-maaslog-exception

lint-doc:
	@./utilities/doc-lint

# JavaScript lint is checked in parallel for speed.  The -n20 -P4 seetting
# worked well on a multicore SSD machine with the files cached, roughly
# doubling the speed, but it may need tuning for slower systems or cold caches.
lint-js: sources = src/maasserver/static/js
lint-js:
	@find $(sources) -type f -print0 '(' -name '*.html' -o -name '*.js' ')' | xargs -r0 -n20 -P4 $(pocketlint)

# Apply automated formatting to all Python files.
format: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
format:
	@find $(sources) -name '*.py' -print0 | xargs -r0 ./utilities/format-imports

check: clean test

docs/api.rst: bin/maas-region-admin src/maasserver/api/doc_handler.py syncdb
	bin/maas-region-admin generate_api_doc > $@

sampledata: bin/maas-region-admin bin/database syncdb
	$(dbrun) bin/maas-region-admin loaddata src/maasserver/fixtures/dev_fixture.yaml

doc: bin/sphinx docs/api.rst
	bin/sphinx

doc-with-versions: bin/sphinx docs/api.rst
	cd docs/_build; make SPHINXOPTS="-A add_version_switcher=true" html

man: $(patsubst docs/man/%.rst,man/%,$(wildcard docs/man/*.rst))

man/%: docs/man/%.rst | bin/sphinx-build
	bin/sphinx-build -b man docs man $^

enums: $(js_enums)

$(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
	 bin/py -m src/maasserver/utils/jsenums $(py_enums) > $@

clean:
	$(MAKE) -C acceptance $@
	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
	find . -type f -name '*~' -print0 | xargs -r0 $(RM)
	find . -type f -name dropin.cache -print0 | xargs -r0 $(RM)
	$(RM) -r media/demo/* media/development
	$(RM) $(js_enums)
	$(RM) *.log
	$(RM) docs/api.rst
	$(RM) -r docs/_autosummary docs/_build
	$(RM) -r man/.doctrees

distclean: clean stop
	$(RM) -r bin include lib local
	$(RM) -r eggs develop-eggs
	$(RM) -r build dist logs/* parts
	$(RM) tags TAGS .installed.cfg
	$(RM) -r *.egg *.egg-info src/*.egg-info
	$(RM) -r run/* services/*/supervise

harness: bin/maas-region-admin bin/database
	$(dbrun) bin/maas-region-admin shell --settings=maas.demo

dbharness: bin/database
	bin/database --preserve shell

syncdb: bin/maas-region-admin bin/database
	$(dbrun) bin/maas-region-admin syncdb --noinput
	$(dbrun) bin/maas-region-admin migrate maasserver --noinput
	$(dbrun) bin/maas-region-admin migrate metadataserver --noinput

# (Re)write the baseline schema.
schema/baseline.sql: bin/database
	$(dbrun) pg_dump -h $(PWD)/db/ -d maas --no-owner --no-privileges -f $@

# Synchronise the database, and update the baseline schema.
baseline-schema: syncdb schema/baseline.sql

define phony_targets
  build
  check
  clean
  dbharness
  distclean
  doc
  enums
  format
  harness
  install-dependencies
  lint
  lint-css
  lint-doc
  lint-js
  lint-py
  man
  package
  sampledata
  source_package
  syncdb
  test
endef

#
# Development services.
#

service_names_region := database dns reloader web webapp
service_names_cluster := pserv reloader
service_names_all := $(service_names_region) $(service_names_cluster)

# The following template is intended to be used with `call`, and it
# accepts a single argument: a target name. The target name must
# correspond to a service action (see "Pseudo-magic targets" below).
# A region- and cluster-specific variant of the target will be
# created, in addition to the target itself. These can be used to
# apply the service action to the region services, the cluster
# services, or all services, at the same time.
define service_template
$(1)-region: $(patsubst %,services/%/@$(1),$(service_names_region))
$(1)-cluster: $(patsubst %,services/%/@$(1),$(service_names_cluster))
$(1): $(1)-region $(1)-cluster
phony_services_targets += $(1)-region $(1)-cluster $(1)
endef

# Expand out aggregate service targets using `service_template`.
$(eval $(call service_template,pause))
$(eval $(call service_template,restart))
$(eval $(call service_template,start))
$(eval $(call service_template,status))
$(eval $(call service_template,stop))
$(eval $(call service_template,supervise))

# The `run` targets do not fit into the mould of the others.
run-region:
	@services/run $(service_names_region)
run-cluster:
	@services/run $(service_names_cluster)
run:
	@services/run $(service_names_all)

phony_services_targets += run-region run-cluster run

# This one's for the rapper, yo.
run+webapp:
	@services/run $(service_names_region) +webapp

phony_services_targets += run+webapp

# Convenient variables and functions for service control.

setlock = $(call available,setlock,daemontools)
supervise = $(call available,supervise,daemontools)
svc = $(call available,svc,daemontools)
svok = $(call available,svok,daemontools)
svstat = $(call available,svstat,daemontools)

service_lock = $(setlock) -n /run/lock/maas.dev.$(firstword $(1))

# Pseudo-magic targets for controlling individual services.

services/%/@run: services/%/@stop services/%/@deps
	@$(call service_lock, $*) services/$*/run

services/%/@start: services/%/@supervise
	@$(svc) -u $(@D)

services/%/@pause: services/%/@supervise
	@$(svc) -d $(@D)

services/%/@status:
	@$(svstat) $(@D)

services/%/@restart: services/%/@supervise
	@$(svc) -du $(@D)

services/%/@stop:
	@if $(svok) $(@D); then $(svc) -dx $(@D); fi
	@while $(svok) $(@D); do sleep 0.1; done

services/%/@supervise: services/%/@deps
	@mkdir -p logs/$*
	@touch $(@D)/down
	@if ! $(svok) $(@D); then \
	    logdir=$(CURDIR)/logs/$* \
	        $(call service_lock, $*) $(supervise) $(@D) & fi
	@while ! $(svok) $(@D); do sleep 0.1; done

# Dependencies for individual services.

services/dns/@deps: bin/py

services/database/@deps: bin/database

services/pserv/@deps: bin/twistd.pserv

services/reloader/@deps:

services/web/@deps:

services/webapp/@deps: bin/maas-region-admin

#
# Package building
#
# This ought to be as simple as using bzr builddeb --export-upstream but it
# has a bug and always considers apt-source tarballs before the specified
# branch.  So instead, export to a local tarball which is always found.
# Make sure debhelper and dh-apport packages are installed before using this.
PACKAGING := $(CURDIR)/../packaging.utopic
PACKAGING_BRANCH := lp:~maas-maintainers/maas/packaging.utopic

package_branch:
	@echo Downloading/refreshing packaging branch...
	@if [ ! -d $(PACKAGING) ]; then \
		bzr branch $(PACKAGING_BRANCH) $(PACKAGING); \
		else bzr pull -d $(PACKAGING); fi

# Make sure an orig tarball generated from the current branch is placed in the
# build area.
package_export: VER = $(shell dpkg-parsechangelog -l$(PACKAGING)/debian/changelog | sed -rne 's,^Version: ([^-]+).*,\1,p')
package_export: TARBALL = maas_$(VER).orig.tar.gz
package_export: package_branch
	@$(RM) -f ../build-area/$(TARBALL)
	@mkdir -p ../build-area
	@bzr export --root=maas-$(VER).orig ../build-area/$(TARBALL) $(CURDIR)

package: package_export
	bzr bd --merge $(PACKAGING) --result-dir=../build-area -- -uc -us
	@echo Binary packages built, see ../build-area/ directory.

source_package: package_export
	bzr bd --merge $(PACKAGING) --result-dir=../build-area -- -S -uc -us
	@echo Source package built, see ../build-area/ directory.

#
# Phony stuff.
#

define phony
  $(phony_services_targets)
  $(phony_targets)
endef

phony := $(sort $(strip $(phony)))

.PHONY: $(phony)

#

=== debian/changelog ===
maas (1.7.6+bzr3376-0ubuntu2~14.10.1) utopic; urgency=medium

  * debian/control: Make maas-dns a Dependy of maas-region-controller.
  * debian/maas-region-controller.postinst: Ensure DNS config migration is
    always run. (LP: #1413388)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 10 Jul 2015 13:47:40 -0400

maas (1.7.6+bzr3376-0ubuntu1) wily; urgency=medium

  * New upstream release 1.7.6 bzr3376:
    - Accept list of forwarders for upstream_dns rather than just
      one. (LP: #1470585)
    - Fix upgrade issue where it would remove custom DNS config,
      potentially breaking DNS. (LP: #1413388)

  [ Raphaël Badin ]
  * Drop dependency on python-iscpy: the code has been integrated into
    MAAS. (LP: #1413388).

  [ Andres Rodriguez ]
  * Refactor maas-dns upgrade code so it doesn't break local DNS config
    and it gets migrated (LP: #1413388)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 03 Jul 2015 00:11:50 -0400

maas (1.7.5+bzr3369-0ubuntu1) vivid; urgency=medium

  * New upstream release, MAAS 1.7.5 bzr3369 (LP: #1460737):
    - MAAS cli/API: missing option set use-fast-installer /
      use-debian-installer (LP: #1456969)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 11 May 2015 12:43:31 +0100

maas (1.7.4+bzr3366-0ubuntu1) vivid; urgency=medium

  * New upstream release, MAAS 1.7.4 bzr3365:
    - When MAAS has too many leases, and lease parsing fails, MAAS fails
      to auto-map NIC with network. (LP: #1387859)
    - Alert a command-line user of `maas` when their local API description
      is out-of-date. (LP: #1329267)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Sat, 09 May 2015 12:07:15 +0100

maas (1.7.3+bzr3363-0ubuntu2) vivid; urgency=medium

  * Use python-django16 instead of python-django ( 1.7). MAAS does not
    support django 1.7 due to having a new migration system. (LP: #1447573)
  * Adding systemd units and packaging support. (LP: #1423613)
  * debian/control: Add missing dependency on python-apt. (LP: #1446878)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 22 Apr 2015 12:10:50 -0400

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Build-Depends: debhelper (>= 8.1.0~),
                dh-apport,
+               dh-systemd,
                po-debconf,
                python (>= 2.7),
                python-distribute,
@@ -55,7 +56,8 @@
          libjs-yui3-full,
          libjs-yui3-min,
          maas-common (= ${binary:Version}),
-         python-django (>= 1.4),
+         python-django16 | python-django (<< 1.7),
+         python-django,
          python-django-maas (= ${binary:Version}),
          python-django-piston,
          python-django-south,
@@ -75,11 +77,12 @@
 
 Package: maas-region-controller
 Architecture: all
-Depends: maas-region-controller-min (= ${binary:Version}),
+Depends: maas-dns (= ${binary:Version}),
+         maas-region-controller-min (= ${binary:Version}),
          postgresql (>= 9.1),
          ${misc:Depends},
          ${python:Depends}
-Recommends: openssh-server, maas-dns (= ${binary:Version})
+Recommends: openssh-server
 Description: MAAS server complete region controller
  This package installs and configures the complete MAAS region controller,
  including the minimum setup, plus the database server and messaging queue.
@@ -181,6 +184,7 @@
 Section: python
 Architecture: all
 Depends: python-amqp,
+         python-apt,
          python-bson,
          python-celery,
          python-convoy,
@@ -214,7 +218,6 @@
 Architecture: all
 Depends: bind9,
  maas-region-controller-min (= ${binary:Version}),
- python-iscpy,
  ${misc:Depends}
 Conflicts: dnsmasq
 Breaks: maas-dhcp (<= 0.1+bzr777+dfsg-0ubuntu1)

=== debian/rules ===
--- 
+++ 
@@ -6,13 +6,25 @@
 py_enums := $(wildcard src/*/enum.py)
 
 %:
-	dh $@ --with python2,apport --buildsystem=python_distutils
+	dh $@ --with python2,apport,systemd --buildsystem=python_distutils
 
 override_dh_installinit:
+	# maas-clusterd
+	dh_systemd_enable --name maas-clusterd
 	dh_installinit --name maas-clusterd
+	dh_systemd_start --name maas-clusterd
+	# maas-dhcpd
+	dh_systemd_enable --name maas-dhcpd
 	dh_installinit --name maas-dhcpd
+	dh_systemd_start --name maas-dhcpd
+	# maas-dhcpd6
+	dh_systemd_enable --name maas-dhcpd6
 	dh_installinit --name maas-dhcpd6
+	dh_systemd_start --name maas-dhcpd6
+	# maas-proxy
+	dh_systemd_enable --name maas-proxy
 	dh_installinit --name maas-proxy
+	dh_systemd_start --name maas-proxy
 
 override_dh_auto_build:
 	dh_auto_build
